alias RadioCastV2 {
  if ($dialog(RadioCastV2) != RadioCastV2) {
    hfree -w RadioCastV2
    hmake RadioCastV2 100
    .hload -si RadioCastV2 " $+ $scriptdir\RadioCastV2.ini $+ " RadioCastV2
    RadioCastV2.plug
    RadioCastV2.maj
    dialog -dom RadioCastV2 RadioCastV2
  }
}

menu menubar {
  Radio: /RadioCastV2
}

dialog RadioCastV2 {
  ;taille normale
  size -1 -1 291 100
  ;fentre principale
  title "Radio WesTinDieS STyLe V4"
  icon $scriptdiricones\120.ico
  button "positioner",1001,0 0 0 0
  list 3,119 10 165 22,size
  text "- - : - -",5,8 7 110 30,center read
  edit "",7,8 43 275 22,left read autohs
  list 4,6 67 280 15,size
  ;liste
  list 8,8 102 275 181,extsel size
  combo 14,8 292 175 150, drop edit size
  list 9,128 288 188 34
  ;recherche
  list 10,8 102 275 181,extsel size
  combo 15,8 292 85 300, drop size
  combo 11,100 292 85 300, drop edit size
  list 12,190 288 100 34
  ;bar
  list 13,-1 320 291 22, size
  ;action touche entre
  button "" 100, 0 0 0 0, default
}

on *:dialog:RadioCastV2:init:*:{
  RadioCastV2.mdxinit
  RadioCastV2.mdx SetControlMDX $dname 1001 positioner size minbox maxbox > $RadioCastV2.dialog
  did -h $dname 8,9,10,11,12,13
  RadioCastV2.mdx SetControlMDX $dname 3 TrackBar noticks select > $RadioCastV2.bars
  RadioCastV2.mdx SetBorderStyle $dname 3 windowedge
  did -i $dname 3 1 params 100 0 100 * * * * 18
  did -i $dname 3 1 tickfreq 1
  RadioCastV2.mdx SetFont $dname 5 26 900 Tahoma
  RadioCastV2.mdx SetFont $dname 7,45 13 900 Tahoma
  RadioCastV2.mdx SetColor $dname 5,7,45 text $rgb(6,100,176)
  RadioCastV2.mdx SetControlMDX $dname 4,9,12 toolbar flat nodivider > $RadioCastV2.bars
  RadioCastV2.mdx SetFont $dname 4,9,12 +a 13 400 tahoma
  RadioCastV2.mdx SetBorderStyle $dname 4,9,12
  did -i $dname 4,9,12 1 bmpsize 24 24
  did -i $dname 4 1 setimage +ndh 0 icon large $scriptdiricones\prev.ico
  did -i $dname 4 1 setimage +ndh 0 icon large $scriptdiricones\play.ico
  did -i $dname 4 1 setimage +ndh 0 icon large $scriptdiricones\pause.ico
  did -i $dname 4 1 setimage +ndh 0 icon large $scriptdiricones\stop.ico
  did -i $dname 4 1 setimage +ndh 0 icon large $scriptdiricones\suiv.ico
  did -i $dname 4,12 1 setimage +ndh 0 icon large $scriptdiricones\eject.ico
  did -i $dname 4 1 setimage +ndh 0 icon large $scriptdiricones\4.ico
  did -i $dname 4 1 setimage +ndh 0 icon large $scriptdiricones\124.ico
  did -i $dname 4 1 setimage +ndh 0 icon large $scriptdiricones\speaker.ico
  did -i $dname 4 1 setimage +ndh 0 icon large $scriptdiricones\123.ico
  did -a $dname 4 1 $chr(9) $+ Prcdent
  did -a $dname 4 2 $chr(9) $+ Lecture
  did -a $dname 4 3 $chr(9) $+ Pause
  did -a $dname 4 4 $chr(9) $+ Stop
  did -a $dname 4 5 $chr(9) $+ Suivant
  did -a $dname 4 6 $chr(9) $+ Rechercher un titre
  did -a $dname 4 7 $chr(9) $+ Afficher la liste de lecture
  did -a $dname 4 8 $chr(9) $+ Accder au site de la radio en cours
  did -a $dname 4 9 $chr(9) $+ Muet
  RadioCastV2.mdx SetControlMDX $dname 8,10 ListView report showsel single > $RadioCastV2.views
  did -i $dname 10 1 headerdims 250 110 70 50 55 65 70
  did -i $dname 8 1 headerdims 175 70
  did -i $dname 10 1 headertext Titre $chr(9) En cours $chr(9) Genre $chr(9) Codec $chr(9) Bitrate $chr(9) Auditeurs $chr(9) Identifiant
  did -i $dname 8 1 headertext Titre $chr(9) Lien
  did -i $dname 8,10 1 settxt color $rgb(6,100,176)
  did -i $dname 8,10 1 seticon normal 0 0, $+ $scriptdiricones\audio.ico
  did -i $dname 8,10 1 seticon normal 0 0, $+ $scriptdiricones\audio2.ico
  RadioCastV2.mdx SetControlMDX $dname 9 toolbar flat nodivider list > $RadioCastV2.bars
  did -i $dname 9 1 setimage +ndh 0 icon large $scriptdiricones\save.ico
  did -i $dname 9 1 setimage +ndh 0 icon large $scriptdiricones\trash.ico
  did -i $dname 9 1 setimage +ndh 0 icon large $scriptdiricones\104.ico
  did -i $dname 9 1 setimage +ndh 0 icon large $scriptdiricones\down.ico
  did -a $dname 9 1 $chr(9) $+ Sauvegarder la liste
  did -a $dname 9 2 $chr(9) $+ Supprimer la liste
  did -a $dname 9 3 $chr(9) $+ Supprimer la slection
  did -a $dname 9 4 $chr(9) $+ Effacer la liste
  did -i $dname 12,9 1 setimage +ndh 0 icon large $scriptdiricones\add.ico
  did -i $dname 12,9 1 setimage +ndh 0 icon large $scriptdiricones\120.ico
  did -a $dname 9 5 $chr(9) $+ Ajouter une radio
  did -a $dname 9 6 $chr(9) $+ Ecouter la slection
  did -a $dname 12 1 $chr(9) $+ Lancer la recherche
  did -a $dname 12 2 $chr(9) $+ Ajouter  la liste de lecture
  did -a $dname 12 3 $chr(9) $+ Lecture
  RadioCastV2.mdx SetControlMDX $dname 13 StatusBar sizegrip > $RadioCastV2.bars
  RadioCastV2.mdx SetBorderStyle $dname 13 windowedge
  did -i $dname 13 1  seticon 0 small 0, $+ $scriptdiricones\date.ico
  did -i $dname 13 2 2 0 Radio(s) dans la liste
  var %x 1
  var %file " $+ $scriptdir\saveplayliste.ini $+ "
  while %x <= $lines(%file) {
    var %a = $read(%file,w,[*],%x)
    if ($len(%a) > 0) {
      if (%a != [default]) did -a $dname 14 $replace($remove(%a,$chr(91),$chr(93)),_,$chr(32))
      var %x $calc($readn + 2)
    }
    else var %x $calc($lines(%file) + 1)
  }
  var %a 
  didtok RadioCastV2 15 124 Genre rapide|Alatoire|0-9|A|B|C|D|E|F|G|H|I|J|K|L|M|N|O|P|Q|R|S|T|U|V|W|Y|Z
  did -c RadioCastV2 15 1
  RadioCastV2.choix
  did -c RadioCastV2 11 1
  RadioCastV2.open default
  did -a $dname 7 $RadioCastV2.gt(play)
  if $RadioCastV2.gt(num) { did -c $dname 8 $RadioCastV2.gt(num) }
  if ($RadioCastV2.gt(status) == OK playing) RadioCastV2.play
  did -c $dname 14 $RadioCastV2.gt(liste)
}

on *:dialog:RadioCastV2:sclick:*:{
  if ($did != 0) {
    tokenize 32 $did($dname,$did,1)
    if ($did == 2) { did -fu $dname 1001 | RadioCastV2.seek $1 }
    elseif ($did == 3) { did -fu $dname 1001 | RadioCastV2.vol $1 }
    elseif ($did == 4) {
      var %a $did(4).sel
      if (%a == 2) RadioCastV2.prev
      elseif (%a == 3) {
        RadioCastV2.playwithliste
      }
      elseif (%a == 4) RadioCastV2.pause
      elseif (%a == 5) RadioCastV2.stop
      elseif (%a == 6) RadioCastV2.next
      elseif (%a == 7) RadioCastV2.viewliste search
      elseif (%a == 8) RadioCastV2.viewliste liste
      elseif (%a == 9) && ($RadioCastV2.gt(site)) { url -an $RadioCastV2.gt(site) }
      elseif (%a == 10) RadioCastV2.mute
    }
    elseif ($did == 9) {
      var %a $did(9).sel
      if (%a == 2) RadioCastV2.save
      elseif (%a == 3) && ($did($dname,14).sel > 0) {
        remini " $+ $scriptdir\saveplayliste.ini $+ " $replace($did(RadioCastV2,14),$chr(32),_)
        did -d $dname 14 $did($dname,14).sel
      }
      elseif (%a == 4) && ($did(RadioCastV2,8).lines > 1) { did -d $dname 8 $did($dname,8,1).sel | did -i RadioCastV2 13 2 2 $calc($did(RadioCastV2,8).lines - 1) Radio(s) dans la liste }
      elseif (%a == 5) {
        did -r $dname 8
        RadioCastV2.dt num
        did -i RadioCastV2 13 2 2 0 Radio(s) dans la liste
      }
      elseif (%a == 6) RadioCastV2.openurl
      elseif (%a == 7) {
        var %c $gettok($remove($gettok($did($dname,8,1).seltext,1,10),+ 0 0 0),6-,32)
        RadioCastV2.st num $did($dname,8,1).sel
        RadioCastV2.play $gettok(%c,2,9)
      }
    }
    elseif ($did == 100) && $did(11) { RadioCastV2.dt usefor | did -ra RadioCastV2 10 | RadioCastV2.dt searchnum | RadioCastV2.searchshoutcast }
    elseif ($did == 12) {
      var %a $did(12).sel
      if (%a == 2) && $did(11) { RadioCastV2.dt usefor | did -ra RadioCastV2 10 | RadioCastV2.dt searchnum | RadioCastV2.searchshoutcast }
      else {
        var %c $gettok($remove($gettok($did($dname,10,1).seltext,1,10),+ 0 0 0),6-,32)
        if (mp3 !isin $gettok(%c,4,9)) return
        if (%a == 3) {
          RadioCastV2.dt usefor
        }
        else { 
          RadioCastV2.st usefor play
          did -r RadioCastV2 8
          RadioCastV2.dt num
        }
        RadioCastV2.loadurl http://www.shoutcast.com/sbin/tunein-station.pls?id= $+ $mid($gettok(%c,7,9),2)
      }
    }
    elseif ($did == 14) .timerRadioCastV2liste -om 1 10 RadioCastV2.open
    elseif ($did == 11) {
      did -ra RadioCastV2 10
      RadioCastV2.dt searchnum
      .timerRadioCastV2search -om 1 10 RadioCastV2.searchshoutcast
    }
    elseif ($did == 15) RadioCastV2.choix
    elseif ($1 == sizing) || ($1 == size) RadioCastV2.resize $2-
  }
}

on *:dialog:RadioCastV2:dclick:*:{
  var %c $gettok($remove($gettok($did($dname,$did,1).seltext,1,10),+ 0 0 0),6-,32)
  if ($did == 10) {
    if (mp3 !isin $gettok(%c,4,9)) return
    RadioCastV2.st usefor play
    did -r RadioCastV2 8
    RadioCastV2.dt num
    RadioCastV2.loadurl http://www.shoutcast.com/sbin/tunein-station.pls?id= $+ $mid($gettok(%c,7,9),2)
  }
  if ($did == 8) {
    RadioCastV2.st num $did(RadioCastV2,8).sel
    RadioCastV2.play $gettok(%c,2,9)
  }
}

on *:dialog:RadioCastV2:close:*:{
  .timerRadioCastV2 off
  RadioCastV2.st status $RadioCastV2.state
  var %a $RadioCastV2.dll(Stop,-)
  RadioCastV2.savedefaut
  RadioCastV2.st liste $did(RadioCastV2,14).sel
  .hsave -soi RadioCastV2 " $+ $scriptdir\RadioCastV2.ini $+ " RadioCastV2
}

alias -l RadioCastV2.viewliste {
  if ($1 == search) {
    if ($did(RadioCastV2,10).visible == $true) { did -h RadioCastV2 10,11,12,13,15 | dialog -s RadioCastV2 -1 -1 $calc($dialog(RadioCastV2).cw + 2) 102  }
    else {
      RadioCastV2.st listeuse search
      if ($did(RadioCastV2,13).visible == $false) dialog -s RadioCastV2 -1 -1 $calc($dialog(RadioCastV2).cw + 2) 344
      did -h RadioCastV2 8,9,14
      did -v RadioCastV2 10,11,12,13,15
      RadioCastV2.resize
      did -f RadioCastV2 11
      did -i RadioCastV2 13 2 2 $calc($did(RadioCastV2,10).lines - 1) Radio(s) dans la liste
    }
  }
  else {
    if ($did(RadioCastV2,8).visible == $true) { did -h RadioCastV2 8,9,13,14 | dialog -s RadioCastV2 -1 -1 $calc($dialog(RadioCastV2).cw + 2) 102 }
    else {
      RadioCastV2.st listeuse playliste
      if ($did(RadioCastV2,13).visible == $false) dialog -s RadioCastV2 -1 -1 $calc($dialog(RadioCastV2).cw + 2) 344
      did -v RadioCastV2 8,9,13,14
      did -h RadioCastV2 10,11,12,15
      RadioCastV2.resize
      did -i RadioCastV2 13 2 2 $calc($did(RadioCastV2,8).lines - 1) Radio(s) dans la liste
    }
  }
}

alias -l RadioCastV2.resize {
  if ($did(RadioCastV2,10).visible == $false) && ($did(RadioCastV2,8).visible == $false) {
    did -a RadioCastV2 1001 setSize c $iif($8 <= 291,291,$8) 100
  }
  else did -a RadioCastV2 1001 setSize c $iif($8 <= 291,291,$8) $iif($9 <= 342,342,$9)
  var %a $dialog(RadioCastV2).cw
  var %b $dialog(RadioCastV2).ch
  if ($did(RadioCastV2,10).visible == $true) || ($did(RadioCastV2,8).visible == $true) {
    RadioCastV2.move 13 * $calc(%b - 22) %a
    RadioCastV2.move 14 * $calc(%b - 52) $calc(%a - 204)
    RadioCastV2.move 9 $calc(%a - 194) $calc(%b - 56)
    RadioCastV2.move 8 * * $calc(%a - 16) $calc(%b - 163)
    RadioCastV2.move 10 * * $calc(%a - 16) $calc(%b - 163)
    var %c $calc(%a - 40)

    if (%c <= 500) did -i $dname 10 1 headerdims 100 100 50 55 55 70 70
    else {
      var %c $calc(%c - 250)
      did -i $dname 10 1 headerdims $calc(%c * 2 / 5) $calc(%c * 2 / 5) $calc(%c * 1 / 5) 55 55 70 70
    }
    did -i $dname 8 1 headerdims $calc((%a - 40) *3  / 4) $calc((%a - 40) / 4)
    RadioCastV2.move 15 * $calc(%b - 52)
    RadioCastV2.move 11 * $calc(%b - 52) $calc(%a - 205)
    RadioCastV2.move 12 $calc(%a - 101) $calc(%b - 56)
  }
  RadioCastV2.move 7 * * $calc(%a - 16)
  RadioCastV2.move 2 * * $calc(%a - 13)
  RadioCastV2.move 4 $calc(%a / 2 - 140)
}

alias -l RadioCastV2.move {
  RadioCastV2.mdx MoveControl RadioCastV2 $1-
}

alias RadioCastV2.choix {
  did -r RadioCastV2 11
  var %a $did(RadioCastV2,15).sel
  if (%a == 2) {
    did -ra RadioCastV2 10
    RadioCastV2.dt searchnum
    RadioCastV2.searchshoutcast random
  }
  else {
    if (%a == 1) var %b Top500|70s|80s|Alternative|classical|Comedy|Country|Dance|Electro|Funk|House|Jazz|Metal|Mixed|Pop|Punk|Rap|RnB|Rock|Talk|Techno|Trance|World
    elseif (%a == 3) var %b 50s|60s|70s|80s|90s
    elseif (%a == 4) var %b Acid|Adult|Adulto|African|Aktywista|Albanian|Alt|Alternative|Alternativo|Amateur|Ambient|Americana|Anime|Anni|Any|Anything|Arabic|Asian|Auto|Autopilot
    elseif (%a == 5) var %b Bachata|Balada|Baladass|Bangla|Best|Bhangra|Big|Black|Bluegrass|Blues|Bollywood|Brasil|Brazilian|Breakbeat|Breaks
    elseif (%a == 6) var %b Canal|Caribbean|Carnaval|Catholic|Celtic|Charts|Children|Chil|Chillout|Chinese|Chr|Christian|Christmas|Clasicos|Classic|Club|College|Comedy|Community|Contemporary|Country|Cowboy|Cristiana|Croatian
    elseif (%a == 7) var %b dance|Dancehall|Dark|Darkwave|Death|Deejay|Deep|Deportes|Desi|Die|Disco|Discofox|Disney|Dnb|Domaca|Dominicana|Downtempo|Dream|Drum|Dub
    elseif (%a == 8) var %b Easy|Ebm|Eclectic|Electro|Electronic|Electronica|Elektro|Emisora|Emo|Ethnic|Euro|Eurodance|Everything|Exitos|Experimental
    elseif (%a == 9) var %b Fantasy|Film|Fire|Folk|Folklore|Free|Freestyle|Full|Funk|Funky
    elseif (%a == 10) var %b Game|Games|Gaming|garage|Gay|Generaliste|Genre|Genres|german|Goa|Golden|Good|Gospel|Goth|Gothic|Greece|Greek|Grupera|Gurbani
    elseif (%a == 11) var %b Hair|Haitian|Halk|Ham|Happy|Hard|Hardcore|Hardstyle|Hawaiian|Heavy|Hindy|Hip|Hiphop|Hit|Hits|Hollands|Hot|House|Http
    elseif (%a == 12) var %b Idm|Independant|Indian|Indie|Industrial|Infos|Instrumental|Iraqi|Islam|Israel|Italian|Italo|Ivairi
    elseif (%a == 13) var %b Jam|Japanese|Jazz|Jewish|Jpop|Jump|Jumpstyle|Jungle|Just
    elseif (%a == 14) var %b Kanal|Kizomba
    elseif (%a == 15) var %b Latin|Latina|Latino|Live|Local|Lokale|Lounge|Love
    elseif (%a == 16) var %b Macedonian|Manele|Merengue|Metal|Mexican|Middle|Minimal|Mix|Mixed|Modern|Mostly|Mp3|Multi|Music|Musica|Musical|Musik|Musique|Muzica|Muzika|Muzyka
    elseif (%a == 17) var %b Narodna|Ned|Nederlands|Nederlandse|Nederlandstalig|New|News|Nigerian|Non|Nonstop|Norte|Noticias|Npr
    elseif (%a == 18) var %b Old|Oldies|Oldschool|Oldskool|Only|Original|Other|Otr
    elseif (%a == 19) var %b Pagan|Paranormal|Party|Persian|pilot|Pinoy|Piraat|Piraten|Piratenhits|Polska|polski|Polskie|Pop|Poprock|Popular|Post|Praise|Progressive|psy|Psychedelic|Psytrance|Public|Punjabi|Punk
    elseif (%a == 20) var %b Querbeet
    elseif (%a == 21) var %b R&b|Radio|Radyo|Ragga|Railroad|Rap|Reggae|Reggaeton|Regional|relax|Religion|Restro|Rnb|Rock|Rockabilly|Romania|Romanian|Roots|Russian
    elseif (%a == 22) var %b Salsa|Scanner|Schlager|Schranz|Shqip|Sinhala|Ska|Slow|Smooth|Soca|Soft|Solo|Soul|Souful|Soundtrack|Soundtracks|Spain|Spanish|Spiritual|Spoken|Sports|Synhpop
    elseif (%a == 23) var %b Talk|Tamil|Techno|Tejano|Tel|Test|The|Top|Top40|Tout|Traditional|Trance|Trip|Tropical|True|Turk|Turkce|Turkish
    elseif (%a == 24) var %b Underground|Unsigned|Urban
    elseif (%a == 25) var %b Van|Vari|variado|variety|Varios|Varios|Various|Video|Vietnamese|Vocal
    elseif (%a == 26) var %b Welcome|West|Western|Whatever|WorldWust|Www
    elseif (%a == 27) var %b Yugo
    elseif (%a == 28) var %b Zabavna|Zouk
    didtok RadioCastV2 11 124 %b
    did -c RadioCastV2 11 1
  }
}

;//////////////////// RECHERCHE //////////////////////

alias RadioCastV2.searchshoutcast {
  var %a = $replace($did(RadioCastV2,11),$chr(32),% $+ 20)
  RadioCastV2.st searchshoutcast %a
  if ($1 == random) RadioCastV2.loadurl http://www.shoutcast.com/sbin/newxml.phtml?random=20
  elseif ($istok($didtok(RadioCastV2,11,124),%a,124) == $false) || ($did(RadioCastV2,15) != genre rapide) RadioCastV2.loadurl http://www.shoutcast.com/sbin/newxml.phtml?search= $+ %a
  else RadioCastV2.loadurl http://www.shoutcast.com/sbin/newxml.phtml?genre= $+ %a
}

;/////////////////// MDX /////////////////////

alias -l RadioCastV2.mdx_fullpath { return $+(", $+ $scriptdirdlls\mdx\mdx.dll $+,") }

alias -l RadioCastV2.mdx { dll $RadioCastV2.mdx_fullpath $1- }

alias -l RadioCastV2.mdxinit {
  dll $RadioCastV2.mdx_fullpath SetMircVersion $version
  dll $RadioCastV2.mdx_fullpath MarkDialog $dname
}

alias -l RadioCastV2.dialog {
  return $scriptdirdlls\mdx\dialog.mdx
}

alias -l RadioCastV2.bars {
  return $scriptdirdlls\mdx\bars.mdx
}

alias -l RadioCastV2.views {
  return $scriptdirdlls\mdx\views.mdx
}

;///////////////// HTABLE //////////////

alias -l RadioCastV2.st {
  hadd RadioCastV2 $1-
}

alias -l RadioCastV2.gt {
  return $hget(RadioCastV2,$1)
}

alias -l RadioCastV2.dt {
  hdel RadioCastV2 $1
}

;//////////////////////// TELECHARGEMENTS /////////////////////////

alias RadioCastV2.loadurl {
  sockclose RadioCastV2
  if (tunein-station !isin $1-) did -i RadioCastV2 13 2 2 recherche en cours veuillez patienter...
  RadioCastV2.st url $1-
  sockopen RadioCastV2 $gettok($1-,2,47) 80
}

on *:sockopen:RadioCastV2:{
  sockwrite -n RadioCastV2 GET $RadioCastV2.gt(url)
}

on *:sockread:RadioCastV2:{
  if ($sockerr > 0) return
  :nextread
  sockread 131072 %c
  if ($sockbr == 0) return
  var %c = $left(%c,940)
  if (station name isin %c) {
    var %titre = $mid($left(%c,$calc($pos(%c,mt=,1) - 3)),16)
    var %w $calc($pos(%c,mt=,1) + 4)
    var %x $calc($pos(%c,id=,1) - 2)
    var %codec = $replace($mid(%c,%w,$calc(%x - %w)),audio/mpeg,mp3,audio/aacp,AAC+)
    var %w $calc($pos(%c,id=,1) + 4)
    var %x $calc($pos(%c,br=,1) - 2)
    var %id = $mid(%c,%w,$calc(%x - %w))
    var %w $calc($pos(%c,br=,1) + 4)
    var %x $calc($pos(%c,genre=,1) - 2)
    var %bitrate = $mid(%c,%w,$calc(%x - %w))
    var %w $calc($pos(%c,genre=,1) + 7)
    var %x $calc($pos(%c,ct=,1) - 2)
    var %genre = $mid(%c,%w,$calc(%x - %w))
    var %w $calc($pos(%c,ct=,1) + 4)
    var %x $calc($pos(%c,lc,1) - 2)
    var %encours = $mid(%c,%w,$calc(%x - %w))
    var %w $calc($pos(%c,lc=,1) + 4)
    var %x $calc($pos(%c,$chr(47) $+ $chr(62),1) - 2)
    var %lecteurs = $remove($mid(%c,%w),"></station>)
    did -a RadioCastV2 10 0 $iif(%codec == mp3,1,2) 0 0 %titre $chr(9) %encours $chr(9) %genre $chr(9) %codec $chr(9) %bitrate $chr(9) %lecteurs $chr(9) %id
    did -i RadioCastV2 13 2 2 $calc($did(RadioCastV2,10).lines - 1) Radio(s) dans la liste
  }
  elseif ($left(%c,4) == File) {
    RadioCastV2.st file $gettok(%c,2,61)
  }
  elseif ($left(%c,5) == Title) {
    did -a RadioCastV2 8 0 1 0 0 $gettok(%c,2,61) $chr(9) $RadioCastV2.gt(file)
  }
  goto nextread
}

on *:sockclose:RadioCastV2:{
  unset %c
  if ($RadioCastV2.gt(usefor) == play) RadioCastV2.playwithliste
}

///////////// SON ///////////

alias -l RadioCastV2.mute {
  var %a $mid($RadioCastV2.dll(Misc,getvolume),4)
  if (%a == 0) RadioCastV2.vol $gettok($did(RadioCastV2,3,1),1,32)
  else RadioCastV2.vol 0
}

alias -l RadioCastV2.vol {
  var %ampinvol $RadioCastV2.dll(Misc,setvolume $calc($1 / 100 * 255))
}

/////////////// SAUVEGARDE ET OUVERTURE LISTE /////////

alias -l RadioCastV2.save {
  if ($len($did(RadioCastV2,14)) == 0) return
  var %x 2
  var %file " $+ $scriptdir\saveplayliste.ini $+ "
  remini %file $replace($did(RadioCastV2,14),$chr(32),_)
  writeini %file $replace($did(RadioCastV2,14),$chr(32),_) COUNT $calc($did(RadioCastV2,8).lines - 1)
  while %x <= $did(RadioCastV2,8).lines {
    var %d = $gettok($remove($gettok($did(RadioCastV2,8,%x),1,8),+ 0 0 0),6-,32)
    writeini %file $replace($did(RadioCastV2,14),$chr(32),_) TITRE $+ $calc(%x - 1) $gettok(%d,1,9)
    writeini %file $replace($did(RadioCastV2,14),$chr(32),_) URL $+ $calc(%x - 1) $gettok(%d,2,9)
    inc %x
  }
  did -a RadioCastV2 14 $did(RadioCastV2,14)
}

alias -l RadioCastV2.savedefaut {
  var %x 2
  var %file " $+ $scriptdir\saveplayliste.ini $+ "
  remini %file default
  writeini %file default COUNT $calc($did(RadioCastV2,8).lines - 1)
  while %x <= $did(RadioCastV2,8).lines {
    var %d = $gettok($remove($gettok($did(RadioCastV2,8,%x),1,8),+ 0 0 0),6-,32)
    writeini %file default TITRE $+ $calc(%x - 1) $gettok(%d,1,9)
    writeini %file default URL $+ $calc(%x - 1) $gettok(%d,2,9)
    inc %x
  }
}

alias -l RadioCastV2.open {
  did -r RadioCastV2 8
  if !$1 {
    RadioCastV2.dt num
    var %liste $replace($did(RadioCastV2,14),$chr(32),_))
  }
  else var %liste default
  var %file " $+ $scriptdir\saveplayliste.ini $+ "
  var %count = $readini(%file,%liste,count)
  var %x 1
  while %x <= %count {
    var %a = $readini(%file,%liste,TITRE $+ %x)
    var %c = $readini(%file,%liste,URL $+ %x)
    did -a RadioCastV2 8 0 1 0 0 %a $+ $chr(9) %c
    inc %x 1
  }
  did -i RadioCastV2 13 2 2 $calc($did(RadioCastV2,8).lines - 1) Radio(s) dans la liste
}

////////////// LECTURE ///////////////////

alias -l RadioCastV2.prev {
  hdec RadioCastV2 num 1
  RadioCastV2.playwithliste
}

alias -l RadioCastV2.play {
  did -c RadioCastV2 8 $hget(RadioCastV2,num)
  RadioCastV2.st play $1-
  RadioCastV2.stop
  RadioCastV2.dt stream
  RadioCastV2.dt stream2
  RadioCastV2.dt site
  ;  RadioCastV2.dt titre
  var %a $RadioCastV2.dll(Play, $+ $1 $+ .mp3)
  if (OK playing isin %a) .timerRadioCastV2 -om 0 50 RadioCastV2.timer
  else RadioCastV2.playwithliste
}

alias -l RadioCastV2.pause {
  var %a $RadioCastV2.state
  if (%a == OK paused) { return $mid($RadioCastV2.dll(CurrentMusic,unpause),4) }
  elseif (%a == OK playing) { return $mid($RadioCastV2.dll(CurrentMusic,pause),4) }
}

alias -l RadioCastV2.stop {
  .timerRadioCastV2 off
  did -o RadioCastV2 4 9 8 $chr(9) $+ Accder au site de la radio en cours
  var %a $RadioCastV2.dll(Stop,-)
  did -ra RadioCastV2 5 - - : - -
}

alias -l RadioCastV2.next {
  hinc RadioCastV2 num 1
  RadioCastV2.playwithliste
}

alias RadioCastV2.timer {
  if ($RadioCastV2.state == OK stopped) { .timerRadioCastV2 off | RadioCastV2.playwithliste }
  else {
    var %a $RadioCastV2.pos
    if %a != $did(RadioCastV2,5) did -ra RadioCastV2 5 %a
    var %a $RadioCastV2.current
    if %a != $did(RadioCastV2,7) {
      did -ra RadioCastV2 7 %a
      ;      tokenize 32 %a
      ;      if $len($1-) > 1 {
      ;        if (A suivre !isin $1-) && ($1- != $hget(RadioCastV2,titre)) {
      ;          hadd RadioCastV2 titre $1-
      ;          .timerRCafftitallchan -o 1 3 scid -at1 ame coute $1- - RadioCast V2
      ;        }
      ;    }
    }
  }
}

alias -l RadioCastV2.dll {
  var %a = $dll($scriptdirdlls\ampin\amp_in.dll,$1,$2-)
  return %a
}

alias -l RadioCastV2.plug {
  var %b $shortfn($scriptdirdlls\ampin\amp_in.dll)
  var %a $dll(%b,PluginManager,load input $scriptdirdlls\ampin\in_vorbis.dll)
  var %a $dll(%b,PluginManager,load input $scriptdirdlls\ampin\in_mp3.dll)
  var %a $dll(%b,PluginManager,load output $scriptdirdlls\ampin\out_ds.dll)
}

alias -l RadioCastV2.timeconv {
  var %min $int($calc($1 / 60000))
  var %sec $int($calc($1 / 1000 - 60 * %min))
  if (%min > 59) {
    var %hour $int($calc(%min / 60))
    var %min $int($calc(%min - %hour * 60))
  }
  if (%min < 10) var %min 0 $+ %min
  if (%sec < 10) var %sec 0 $+ %sec
  $iif(%hour,return %hour $+ : $+ %min $+ : $+ %sec,return %min $+ : $+ %sec)
}

alias -l RadioCastV2.pos {
  return $RadioCastV2.timeconv($gettok($RadioCastV2.dll(CurrentMusic,position),2,32))
}

alias -l RadioCastV2.current {
  if ($mid($RadioCastV2.dll(CurrentMusic,status),4) != stopped) {
    var %a $mid($RadioCastV2.dll(CurrentMusic,title),4)
    var %b $remove(%a,$chr(40),$chr(41),$chr(93),$chr(91),$chr(123),$chr(125))
    if (www isin %b) {
      if ($len($RadioCastV2.gt(site)) == 0) did -o RadioCastV2 4 9 10 $chr(9) $+ Accder au site de la radio en cours
      RadioCastV2.st site $matchtok(%b,www,1,32)
    }
    else if .com isin %b {
      if ($len($RadioCastV2.gt(site)) == 0) did -o RadioCastV2 4 9 10 $chr(9) $+ Accder au site de la radio en cours
      RadioCastV2.st site www. $+ $matchtok(%b,.com,1,32)
    }
    var %b $numtok(%a,40)
    if (($chr(40) isin %a) && (%b > 1) && ($len($gettok(%a,1,40)) > 1) ) {
      RadioCastV2.st stream $gettok(%a,1- $+ $RadioCastV2.testtitreradio(%a) $+ ,40)
      var %d = $remove($gettok(%a,$calc($RadioCastV2.testtitreradio(%a) + 1) $+ -,40),$chr(41),$chr(40))
      if ($RadioCastV2.gt(stream2) != %d) {
        RadioCastV2.st stream2 %d
      }
    }
    else {
      if ((timed out isin %a) || (could not connect isin %a) || (unknown host isin %a)) { }
      elseif (([ICY 200 OK] isin %a) || (HTTP/ isin %a)) { RadioCastV2.dt stream2 }
      elseif (connecting isin %a) { RadioCastV2.dt stream2 | RadioCastV2.st stream connexion... }
      elseif (buffer isin %a) { RadioCastV2.dt stream2 | RadioCastV2.st stream Mise en mmoire tampon... }
      else { 
        if ($len($RadioCastV2.gt(stream2)) == 0) {
        }
        RadioCastV2.st stream $remove(%a,$chr(40),$chr(41)) 
        RadioCastV2.st stream2 $remove(%a,$chr(40),$chr(41)) 
      }
    }
    return $RadioCastV2.gt(stream)
  }
  else RadioCastV2.stop
}

alias -l RadioCastV2.testtitreradio {
  var %a $remove($1-,$chr(32))
  var %x 2
  while %x < $numtok(%a,40) {
    if ($right($gettok(%a,%x,40),1) != $chr(41)) goto a4fin
    inc %x 1
  }
  :a4fin
  return $calc(%x - 1)
}

alias RadioCastV2.state {
  return $RadioCastV2.dll(CurrentMusic,status)
}

alias -l RadioCastV2.playwithliste {
  var %b $RadioCastV2.gt(num)
  if ($len(%b) == 0) || (%b < 2) { var %b 2 | tokenize 32 %b }
  var %c = $did(RadioCastV2,8).lines
  if (%c == 1) && $RadioCastV2.gt(play) {
    RadioCastV2.play $RadioCastV2.gt(play)
  }
  else {
    if (%b > %c ) var %b 2

    if ($1 == next) {
      if  (%b == %c) var %b 2
      else var %b $calc(%b + 1)
    }
    RadioCastV2.st num %b
    var %d = $gettok($remove($gettok($did(RadioCastV2,8,%b),1,8),+ 0 0 0),6-,32)
    RadioCastV2.play $gettok(%d,$numtok(%d,9),9)
  }
}

//////////////// MISE A JOUR ///////

alias -l RadioCastV2.maj {
  if ($sock(RadioCastV2.maj2)) sockclose RadioCastV2.maj2
  if ($sock(RadioCastV2.maj)) sockclose RadioCastV2.maj
  .remove $shortfn($scriptdir\RadioCastV22.mrc)
  sockopen RadioCastV2.maj amigagaamp.free.fr 80
}

on *:sockopen:RadioCastV2.maj:{
  if ($sockerr) {
    return
  }
  sockwrite -n RadioCastV2.maj GET http://amigagaamp.free.fr/Download/maj/RadioCastV2.mrc HTTP/1.0
  sockwrite -n RadioCastV2.maj $CRLF
}

on *:SOCKREAD:RadioCastV2.maj:{
  sockread 131072 %majheaders
  if ($sockbr == 0) return
  if (Content-Length: isin %majheaders) {
    RadioCastV2.st majtaille $gettok(%majheaders,2-,32)
  }
  elseif (Last-Modified: isin %majheaders) {
    if ($gettok(%majheaders,2-,32) == %RadioCastV2.maj) { sockclose RadioCastV2.maj | unset %majheaders | return }
    else set %RadioCastV2.maj $gettok(%majheaders,2-,32)
  }
  if !%majheaders {
    unset %majheaders
    sockrename RadioCastV2.maj RadioCastV2.maj2
  }
}

on *:sockread:RadioCastV2.maj2:{
  :nextread
  sockread 131072 &recu
  if ($sockbr == 0) { return }
  bwrite $shortfn($scriptdir\) $+ RadioCastV22.mrc -1 -1 &recu
  goto nextread
}

on *:sockclose:RadioCastV2.maj2:{
  if (($file($shortfn($scriptdir\RadioCastV22.mrc)).size < $RadioCastV2.gt(majtaille)) || ($file($shortfn($scriptdir\RadioCastV22.mrc)).size < 1000)) return
  else {
    .copy -o $shortfn($scriptdir\RadioCastV22.mrc) $shortfn($scriptdir\RadioCastV2.mrc)
    .remove $shortfn($scriptdir\RadioCastV22.mrc)
    .reload -rs $remove($scriptdir,$mircdir) $+ RadioCastV2.mrc
  }
}

///////////////// Ajouter une ou plusieurs Radio /////////////////

alias RadioCastV2.openurl {
  $iif($dialog(RadioCastV2.openurl),,dialog -oma RadioCastV2.openurl RadioCastV2.openurl)
}

dialog RadioCastV2.openurl {
  title "Ajouter une ou plusieurs Radio(s) mp3"
  size -1 -1 335 112
  icon $scriptdiricones\123.ico
  option pixels
  edit "", 1, 7 20 250 20, autohs
  check "Ajouter plusieurs Radios", 2, 7 90 140 19
  list 3,263 61 80 20, size
  text "Titre:", 4, 7 3 315 16
  check "Ne pas effacer  chaque ajout", 5, 162 90 165 19
  text "Lien (ex: http://stream:8000):", 6, 7 45 315 16
  edit "", 7, 7 62 250 20, autohs
}

on *:dialog:RadioCastV2.openurl:init:*:{
  RadioCastV2.mdxinit
  RadioCastV2.mdx SetControlMDX $dname 3 toolbar flat nodivider  list single > $RadioCastV2.bars
  RadioCastV2.mdx SetFont $dname 3 +a 13 400 tahoma
  RadioCastV2.mdx SetBorderStyle $dname 3
  did -i $dname 3 1 bmpsize 16 16
  did -i $dname 3 1 setimage +ndh 0 icon small $scriptdiricones\add.ico
  did -a $dname 3 1 Ajouter $chr(9) $+ Ajouter l'URL  la liste
}

on *:dialog:RadioCastV2.openurl:sclick:*:{
  if ($did == 3) && $did($dname,1) && $did($dname,7) {
    did -a RadioCastV2 8 0 1 0 0 $did($dname,1) $+ $chr(9) $did($dname,7)
    if ($did($dname,5).state != 1) did -r $dname 1,7
    if ($did($dname,2).state != 1) dialog -x $dname
  }
}
